=== removed file 'drizzled/log.cc'
--- drizzled/log.cc	2009-04-03 22:18:21 +0000
+++ drizzled/log.cc	1970-01-01 00:00:00 +0000
@@ -1,295 +0,0 @@
-/* Copyright (C) 2000-2003 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-
-/**
-  @file
-
-  @brief
-  logging of commands
-
-  @todo
-    Abort logging when we get an error in reading or writing log files
-*/
-
-#include <drizzled/server_includes.h>
-#include <drizzled/replicator.h>
-#include <mysys/hash.h>
-
-#include <mysys/my_dir.h>
-#include <stdarg.h>
-
-#include <drizzled/plugin.h>
-#include <drizzled/error.h>
-#include <drizzled/errmsg_print.h>
-#include <drizzled/gettext.h>
-#include <drizzled/data_home.h>
-#include <drizzled/session.h>
-#include <drizzled/handler.h>
-
-#include <string>
-
-using namespace std;
-
-static const string engine_name("binlog");
-
-StorageEngine *binlog_engine= NULL;
-
-/*
-  Save position of binary log transaction cache.
-
-  SYNPOSIS
-    binlog_trans_log_savepos()
-
-    session      The thread to take the binlog data from
-    pos      Pointer to variable where the position will be stored
- 
-  DESCRIPTION
- 
-    Save the current position in the binary log transaction cache into
-    the variable pointed to by 'pos'
-*/
-
-static void
-binlog_trans_log_savepos(Session *, my_off_t *pos)
-{
-  assert(pos != NULL);
-
-  return;
-}
-
-
-class BinlogEngine : public StorageEngine
-{
-public:
-  BinlogEngine(const string &name_arg)
-    : StorageEngine(name_arg,
-                    HTON_NOT_USER_SELECTABLE | HTON_HIDDEN,
-                    sizeof(my_off_t)) {}
- 
-  virtual int close_connection(Session *)
-  {
-  
-    return 0;
-  }
-  
-  virtual int prepare(Session *session, bool)
-  {
-    /*
-      do nothing.
-      just pretend we can do 2pc, so that MySQL won't
-      switch to 1pc.
-      real work will be done in DRIZZLE_BIN_LOG::log_xid()
-    */
-  
-    (void)replicator_prepare(session);
-  
-    return 0;
-  }
-  
-  /**
-    This function is called once after each statement.
-  
-    It has the responsibility to flush the transaction cache to the
-    binlog file on commits.
-  
-    @param engine  The binlog StorageEngine.
-    @param session   The client thread that executes the transaction.
-    @param all   This is @c true if this is a real transaction commit, and
-                 @false otherwise.
-  
-    @see StorageEngine::commit
-  */
-  virtual int commit(Session *session, bool all)
-  {
-    /*
-      Decision table for committing a transaction. The top part, the
-      *conditions* represent different cases that can occur, and hte
-      bottom part, the *actions*, represent what should be done in that
-      particular case.
-  
-      Real transaction        'all' was true
-  
-      Statement in cache      There were at least one statement in the
-                              transaction cache
-  
-      In transaction          We are inside a transaction
-  
-      Stmt modified non-trans The statement being committed modified a
-                              non-transactional table
-  
-      All modified non-trans  Some statement before this one in the
-                              transaction modified a non-transactional
-                              table
-  
-  
-      =============================  = = = = = = = = = = = = = = = =
-      Real transaction               N N N N N N N N N N N N N N N N
-      Statement in cache             N N N N N N N N Y Y Y Y Y Y Y Y
-      In transaction                 N N N N Y Y Y Y N N N N Y Y Y Y
-      Stmt modified non-trans        N N Y Y N N Y Y N N Y Y N N Y Y
-      All modified non-trans         N Y N Y N Y N Y N Y N Y N Y N Y
-  
-      Action: (C)ommit/(A)ccumulate  C C - C A C - C - - - - A A - A
-      =============================  = = = = = = = = = = = = = = = =
-  
-  
-      =============================  = = = = = = = = = = = = = = = =
-      Real transaction               Y Y Y Y Y Y Y Y Y Y Y Y Y Y Y Y
-      Statement in cache             N N N N N N N N Y Y Y Y Y Y Y Y
-      In transaction                 N N N N Y Y Y Y N N N N Y Y Y Y
-      Stmt modified non-trans        N N Y Y N N Y Y N N Y Y N N Y Y
-      All modified non-trans         N Y N Y N Y N Y N Y N Y N Y N Y
-  
-      (C)ommit/(A)ccumulate/(-)      - - - - C C - C - - - - C C - C
-      =============================  = = = = = = = = = = = = = = = =
-  
-      In other words, we commit the transaction if and only if both of
-      the following are true:
-       - We are not in a transaction and committing a statement
-  
-       - We are in a transaction and one (or more) of the following are
-         true:
-  
-         - A full transaction is committed
-  
-           OR
-  
-         - A non-transactional statement is committed and there is
-           no statement cached
-  
-      Otherwise, we accumulate the statement
-    */
-  
-    if (all || (!session_test_options(session, OPTION_NOT_AUTOCOMMIT | OPTION_BEGIN))) 
-    {
-      return replicator_end_transaction(session, all, true);
-    }
-  
-    return(0);
-  }
-  
-  /**
-    This function is called when a transaction involving a transactional
-    table is rolled back.
-  
-    It has the responsibility to flush the transaction cache to the
-    binlog file. However, if the transaction does not involve
-    non-transactional tables, nothing needs to be logged.
-  
-    @param engine  The binlog StorageEngine.
-    @param session   The client thread that executes the transaction.
-    @param all   This is @c true if this is a real transaction rollback, and
-                 @false otherwise.
-  
-    @see StorageEngine::rollback
-  */
-  virtual int rollback(Session *session, bool all)
-  {
-    int error=0;
-  
-    /* TODO: Fix return type */
-    (void)replicator_end_transaction(session, all, false);
-  
-    return(error);
-  }
-  
-  /**
-    @note
-    How do we handle this (unlikely but legal) case:
-    @verbatim
-      [transaction] + [update to non-trans table] + [rollback to savepoint] ?
-    @endverbatim
-    The problem occurs when a savepoint is before the update to the
-    non-transactional table. Then when there's a rollback to the savepoint, if we
-    simply truncate the binlog cache, we lose the part of the binlog cache where
-    the update is. If we want to not lose it, we need to write the SAVEPOINT
-    command and the ROLLBACK TO SAVEPOINT command to the binlog cache. The latter
-    is easy: it's just write at the end of the binlog cache, but the former
-    should be *inserted* to the place where the user called SAVEPOINT. The
-    solution is that when the user calls SAVEPOINT, we write it to the binlog
-    cache (so no need to later insert it). As transactions are never intermixed
-    in the binary log (i.e. they are serialized), we won't have conflicts with
-    savepoint names when using mysqlbinlog or in the slave SQL thread.
-    Then when ROLLBACK TO SAVEPOINT is called, if we updated some
-    non-transactional table, we don't truncate the binlog cache but instead write
-    ROLLBACK TO SAVEPOINT to it; otherwise we truncate the binlog cache (which
-    will chop the SAVEPOINT command from the binlog cache, which is good as in
-    that case there is no need to have it in the binlog).
-  */
-  
-  virtual int savepoint_set_hook(Session *session, void *sv)
-  {
-    bool error;
-    binlog_trans_log_savepos(session, (my_off_t*) sv);
-    /* Write it to the binary log */
-  
-    error= replicator_statement(session, session->query, session->query_length);
-  
-    return(error);
-  }
-  
-  virtual int savepoint_rollback_hook(Session *session, void *)
-  {
-    bool error;
-  
-    error= replicator_statement(session, session->query, session->query_length);
-  
-    return error;
-  }
-
-  virtual handler* create(TABLE_SHARE*, MEM_ROOT*)
-  {
-    return NULL;
-  }
-
-
-};
-
-/*
-  this function is mostly a placeholder.
-  conceptually, binlog initialization (now mostly done in DRIZZLE_BIN_LOG::open)
-  should be moved here.
-*/
-
-int binlog_init(void *p)
-{
-  StorageEngine** engine= static_cast<StorageEngine **>(p);
-
-  if (binlog_engine == NULL)
-  {
-    binlog_engine= new BinlogEngine(engine_name);
-  }
-
-  *engine= binlog_engine;
-
-  return 0;
-}
-
-drizzle_declare_plugin(binlog)
-{
-  DRIZZLE_STORAGE_ENGINE_PLUGIN,
-  "binlog",
-  "1.0",
-  "MySQL AB",
-  "This is a pseudo storage engine to represent the binlog in a transaction",
-  PLUGIN_LICENSE_GPL,
-  binlog_init, /* Plugin Init */
-  NULL, /* Plugin Deinit */
-  NULL,                       /* status variables                */
-  NULL,                       /* system variables                */
-  NULL                        /* config options                  */
-}
-drizzle_declare_plugin_end;

=== renamed file 'drizzled/message/replication_event.proto' => 'drizzled/message/transaction.proto'
--- drizzled/message/replication_event.proto	2009-04-10 05:31:39 +0000
+++ drizzled/message/transaction.proto	2009-04-10 17:06:58 +0000
@@ -1,32 +1,88 @@
+import "table.proto";
+
 package drizzled.message;
 option optimize_for = SPEED;
 
-message Event {
-  enum Type {
-    DDL = 0;
-    INSERT = 1;
-    DELETE = 2;
-    UPDATE = 3;
-    COMMIT = 4;
-  }
-
-  message Value {
-    repeated string val = 1;
-  }
-
+/*
+  Context for a transaction.
+*/
+message TransactionContext
+{
+  required int32 server_id = 1;
+  required int64 transaction_id = 2;
+}
+
+/*
+  Insert one record into a single table.
+*/
+message InsertRecord
+{
+  repeated Table.Field insert_field = 3;
+  repeated string insert_value = 4;
+}
+
+/*
+  Update one record in a single table.
+*/
+message UpdateRecord
+{
+  repeated Table.Field update_field = 3;
+  repeated string before_value = 4;
+  repeated string after_value = 5;
+  repeated Table.Field where_field = 6;
+  repeated string where_value = 7;
+}
+
+/*
+  Deletes one record in a single table
+*/
+message DeleteRecord
+{
+  repeated Table.Field where_field = 3;
+  repeated string where_value = 4;
+}
+
+/*
+  A component of a transaction -- a single instruction or command
+*/
+message Command
+{
+  enum Type 
+  {
+    START_TRANSACTION = 0;        /* A START TRANSACTION statement */
+    COMMIT = 1;                   /* A COMMIT statement */
+    ROLLBACK = 2;                 /* A ROLLBACK statement */
+    INSERT = 3;                   /* An insert of a single record */
+    DELETE = 4;                   /* A delete of a single record */
+    UPDATE = 5;                   /* An update of a single record */
+    RAW_SQL = 6;                  /* A raw SQL statement */
+  }
   required Type type = 1;
-  required bool autocommit = 2;
-  required string server_id = 3;
-  required uint64 query_id = 4;
-  required string transaction_id = 5;
-  required string schema = 6;
-  optional string table = 7;
-  repeated string field_names = 8;
-  optional string primary_key = 9;
-  repeated Value values = 10;
-  optional string sql = 11;
+  required uint64 timestamp = 2;  /* A nanosecond precision timestamp */
+  /* 
+    Transaction Context is duplicated here so that ChangeRecords may
+    be sent over the wire separately from the rest of the records in
+    a transaction.
+  */
+  required TransactionContext transaction_context = 3;
+  optional string schema = 4;     /* The schema affected */
+  optional string table = 5;      /* The table affected */
+
+  optional string sql = 6;  /* May contain the actual SQL supplied for the original statement */
+
+  /* 
+    The below implement the actual change.  Each ChangeRecord will 
+    have zero or one of the below sub-messages defined. 
+  */
+  optional InsertRecord      insert_record = 7;
+  optional DeleteRecord      delete_record = 8;
+  optional UpdateRecord      update_record = 9;
 }
 
-message EventList {
-  repeated Event event = 1;
+message Transaction
+{
+  required TransactionContext transaction_context = 1;
+  required uint64 start_timestamp = 2;
+  required uint64 end_timestamp = 3;
+  repeated Command command = 4;
 }

=== renamed file 'drizzled/message/replication_event_reader.cc' => 'drizzled/message/transaction_reader.cc'
--- drizzled/message/replication_event_reader.cc	2009-04-10 05:31:39 +0000
+++ drizzled/message/transaction_reader.cc	2009-04-10 17:06:58 +0000
@@ -6,128 +6,174 @@
 #include <fstream>
 #include <string>
 #include <unistd.h>
-#include <drizzled/message/replication_event.pb.h>
+#include <drizzled/message/transaction.pb.h>
 
 using namespace std;
 using namespace drizzled::message;
 
-/*
-  Example reader application for master.info data.
-*/
-
-void printRecord(const ::drizzled::message::EventList *list)
+/**
+ * @file Example application for reading change records and transactions
+ */
+
+void printInsert(const drizzled::message::Command &container, const drizzled::message::InsertRecord &record)
+{
+
+  cout << "INSERT INTO `" << container.schema() << "`.`" << container.table() << "` (";
+
+  int32_t num_fields= record.insert_field_size();
+
+  int32_t x;
+  for (x= 0; x < num_fields; x++)
+  {
+    if (x != 0)
+      cout << ", ";
+
+    const Table::Field f= record.insert_field(x);
+
+    cout << "`" << f.name() << "`";
+  }
+
+  cout << ") VALUES ";
+
+  /* 
+   * There may be an INSERT VALUES (),() type statement.  We know the
+   * number of records is equal to the field_values array size divided
+   * by the number of fields.
+   *
+   * So, we do an inner and an outer loop.  Outer loop is on the number
+   * of records and the inner loop on the number of fields.  In this way, 
+   * we know that record.field_values(outer_loop * num_fields) + inner_loop))
+   * always gives us our correct field value.
+   */
+  int32_t num_records= (record.insert_value_size() / num_fields);
+  int32_t y;
+  for (x= 0; x < num_records; x++)
+  {
+    if (x != 0)
+      cout << ", ";
+
+    cout << "(";
+    for (y= 0; y < num_fields; y++)
+    {
+      if (y != 0)
+        cout << ", ";
+
+      cout << "\"" << record.insert_value((x * num_fields) + y) << "\"";
+    }
+    cout << ")";
+  }
+
+  cout << ";";
+}
+
+void printDeleteWithPK(const drizzled::message::Command &container, const drizzled::message::DeleteRecord &record)
+{
+  cout << "DELETE FROM `" << container.schema() << "`.`" << container.table() << "`";
+
+  int32_t num_where_fields= record.where_field_size();
+  /* 
+   * Make sure we catch anywhere we're not aligning the fields with
+   * the field_values arrays...
+   */
+  assert(num_where_fields == record.where_value_size());
+
+  cout << " WHERE ";
+  int32_t x;
+  for (x= 0; x < num_where_fields; x++)
+  {
+    if (x != 0)
+      cout << " AND "; /* Always AND condition with a multi-column PK */
+
+    const Table::Field f= record.where_field(x);
+
+    /* Always equality conditions */
+    cout << "`" << f.name() << "` = \"" << record.where_value(x) << "\"";
+  }
+}
+
+void printUpdateWithPK(const drizzled::message::Command &container, const drizzled::message::UpdateRecord &record)
+{
+  int32_t num_update_fields= record.update_field_size();
+  int32_t x;
+
+  cout << "UPDATE `" << container.schema() << "`.`" << container.table() << "` SET ";
+
+  for (x= 0;x < num_update_fields; x++)
+  {
+    Table::Field f= record.update_field(x);
+    
+    if (x != 0)
+      cout << ", ";
+
+    cout << "`" << f.name() << "` = \"" << record.after_value(x) << "\"";
+  }
+
+  int32_t num_where_fields= record.where_field_size();
+  /* 
+   * Make sure we catch anywhere we're not aligning the fields with
+   * the field_values arrays...
+   */
+  assert(num_where_fields == record.where_value_size());
+
+  cout << " WHERE ";
+  for (x= 0;x < num_where_fields; x++)
+  {
+    if (x != 0)
+      cout << " AND "; /* Always AND condition with a multi-column PK */
+
+    const Table::Field f= record.where_field(x);
+
+    /* Always equality conditions */
+    cout << "`" << f.name() << "` = \"" << record.where_value(x) << "\"";
+  }
+}
+
+void printTransaction(const drizzled::message::Transaction &transaction)
 {
   int32_t e_size;
 
-  for (e_size= 0; e_size < list->event_size(); e_size++)
+  cout << "/* Start Time: " << transaction.start_timestamp() << " */ START TRANSACTION;"<< endl;
+
+  for (e_size= 0; e_size < transaction.command_size(); e_size++)
   {
-    const Event event= list->event(e_size);
-
-    if (e_size != 0)
-      cout << endl << "##########################################################################################" << endl << endl;
-
-    switch (event.type())
+    const drizzled::message::Command command= transaction.command(e_size);
+
+    drizzled::message::TransactionContext trx= command.transaction_context();
+
+    cout << "/* SID: " << trx.server_id() << " XID: " << trx.transaction_id() << " */ ";
+
+    switch (command.type())
     {
-    case Event::DDL:
-      cout << "DDL ";
-      break;
-    case Event::INSERT:
-      {
-        int32_t x;
-
-        cout << "INSERT INTO " << event.table() << " (";
-
-        for (x= 0; x < event.field_names_size() ; x++)
-        {
-          if (x != 0)
-            cout << ", ";
-
-          cout << event.field_names(x);
-        }
-
-        cout << ") VALUES " << endl;
-
-        for (x= 0; x < event.values_size(); x++)
-        {
-          int32_t y;
-          Event_Value values= event.values(x);
-
-          if (x != 0)
-            cout << ", ";
-
-          cout << "(";
-          for (y= 0; y < values.val_size() ; y++)
-          {
-            if (y != 0)
-              cout << ", ";
-
-            cout << "\"" << values.val(y) << "\"";
-          }
-          cout << ")";
-        }
-
-        cout << ";" << endl;
-        break;
-      }
-    case Event::DELETE:
-      {
-        int32_t x;
-        Event_Value values= event.values(0);
-
-        cout << "DELETE FROM " << event.table() << " WHERE " << event.primary_key() << " IN (";
-
-        for (x= 0; x < values.val_size() ; x++)
-        {
-          if (x != 0)
-            cout << ", ";
-
-          cout << "\"" << values.val(x) << "\"";
-        }
-
-        cout << ")" << endl;
-        break;
-      }
-    case Event::UPDATE:
-      {
-        int32_t count;
-
-        for (count= 0; count < event.values_size() ; count++)
-        {
-          int32_t x;
-          Event_Value values= event.values(count);
-
-          cout << "UPDATE "  << event.table() << " SET ";
-
-          for (x= 1; x < values.val_size() ; x++)
-          {
-            if (x != 1)
-              cout << ", ";
-
-            cout << event.field_names(x - 1) << " = \"" << values.val(x) << "\"";
-          }
-
-          cout << " WHERE " << event.primary_key() << " = " << values.val(0) << endl;
-        }
-
-        break;
-      }
-    case Event::COMMIT:
-      cout << "COMMIT" << endl;
-      break;
+      case Command::START_TRANSACTION:
+        cout << "START TRANSACTION;";
+        break;
+      case Command::COMMIT:
+        cout << "COMMIT;";
+        break;
+      case Command::ROLLBACK:
+        cout << "ROLLBACK;";
+        break;
+      case Command::INSERT:
+      {
+        printInsert(command, command.insert_record());
+        break;
+      }
+      case Command::DELETE:
+      {
+        printDeleteWithPK(command, command.delete_record());
+        break;
+      }
+      case Command::UPDATE:
+      {
+        printUpdateWithPK(command, command.update_record());
+        break;
+      }
+      default:
+      assert(0);
     }
     cout << endl;
-
-    if (event.has_sql())
-      cout << "Original SQL: " << event.sql() << endl;
-
-    cout << "AUTOCOMMIT: " << event.autocommit() << endl;
-    cout << "Server id: " << event.server_id() << endl;
-    cout << "Query id: " << event.query_id() << endl;
-    cout << "Transaction id: " << event.transaction_id() << endl;
-    cout << "Schema: " << event.schema() << endl;
-    if (event.type() != Event::DDL)
-      cout << "Table Name: " << event.table() << endl;
   }
+  cout << "/* Commit Time: " << transaction.end_timestamp() << " */ COMMIT;" << endl;
 }
 
 int main(int argc, char* argv[])
@@ -137,22 +183,23 @@
 
   if (argc != 2)
   {
-    cerr << "Usage:  " << argv[0] << " replication event log " << endl;
+    cerr << "Usage:  " << argv[0] << " TRANSACTION_LOG" << endl;
     return -1;
   }
 
-  EventList list;
+  Transaction transaction;
 
   if ((file= open(argv[1], O_RDONLY)) == -1)
   {
-    cerr << "Can not open file: " << argv[0] << endl;
+    cerr << "Can not open file: " << argv[1] << endl;
   }
 
+  char *buffer= NULL;
+  char *temp_buffer;
+
   while (1)
   {
     uint64_t length;
-    char *buffer= NULL;
-    char *temp_buffer;
 
     /* Read the size */
     if (read(file, &length, sizeof(uint64_t)) != sizeof(uint64_t))
@@ -163,26 +210,27 @@
       cerr << "Attempted to read record bigger than SIZE_MAX" << endl;
       exit(1);
     }
+
     temp_buffer= (char *)realloc(buffer, (size_t)length);
     if (temp_buffer == NULL)
     {
-      cerr << "Memory allocation failure trying to " << length << "."  << endl;
+      cerr << "Memory allocation failure trying to allocate " << length << " bytes."  << endl;
       exit(1);
     }
+    memset(temp_buffer, 0, length);
     buffer= temp_buffer;
+    size_t read_bytes= 0;
 
-    /* Read the record */
-    if (read(file, buffer, (size_t)length) != (ssize_t)length)
+    /* Read the transaction */
+    if ((read_bytes= read(file, buffer, (uint64_t)length)) != (uint64_t)length)
     {
-      cerr << "Could not read entire record." << endl;
+      cerr << "Could not read entire transaction. Read " << read_bytes << " bytes instead of " << length << " bytes." << endl;
       exit(1);
     }
-    list.ParseFromArray(buffer, (int)length);
+    transaction.ParseFromArray(buffer, (int) length);
 
-    /* Print the record */
-    printRecord(&list);
+    /* Print the transaction */
+    printTransaction(transaction);
   }
-
-
   return 0;
 }

=== renamed file 'drizzled/message/replication_event_writer.cc' => 'drizzled/message/transaction_writer.cc'
--- drizzled/message/replication_event_writer.cc	2009-04-10 05:31:39 +0000
+++ drizzled/message/transaction_writer.cc	2009-04-10 17:06:58 +0000
@@ -5,122 +5,155 @@
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <string>
-#include <uuid/uuid.h>
-
-#include <drizzled/message/replication_event.pb.h>
+
+#include <sys/time.h>
+
+#include <drizzled/message/transaction.pb.h>
+
+/** 
+ * @file Example script for writing transactions to a log file.
+ */
 
 using namespace std;
 using namespace drizzled::message;
 
-static uint64_t query_id= 0;
-char transaction_id[37];
-
-/*
-  Example script for reader a Drizzle master replication list.
-*/
-
-void write_ddl(::drizzled::message::Event *record, const char *sql)
-{
-  uuid_t uu;
-
-  uuid_generate_time(uu);
-  uuid_unparse(uu, transaction_id);
-
-  record->set_type(Event::DDL);
-  record->set_autocommit(true);
-  record->set_server_id("localhost");
-  record->set_query_id(query_id++);
-  record->set_transaction_id(transaction_id);
-  record->set_schema("test");
-  record->set_sql(sql);
-}
-
-void write_insert(::drizzled::message::Event *record, const char *trx)
-{
-  Event::Value *value;
-
-  record->set_type(Event::INSERT);
-  record->set_autocommit(true);
-  record->set_server_id("localhost");
-  record->set_query_id(query_id++);
-  record->set_transaction_id(trx);
-  record->set_schema("test");
-  record->set_table("t1");
-  record->set_sql("INSERT INTO t1 (a) VALUES (1) (2)");
-
-  /* Add Field Names */
-  record->add_field_names("a");
-
-  /* Add values (first row) */
-  value= record->add_values();
-  value->add_val("1");
-
-  /* Add values (second row) */
-  value= record->add_values();
-  value->add_val("2");
-}
-
-void write_delete(::drizzled::message::Event *record, const char *trx)
-{
-  Event::Value *value;
-
-  record->set_type(Event::DELETE);
-  record->set_autocommit(true);
-  record->set_server_id("localhost");
-  record->set_query_id(query_id++);
-  record->set_transaction_id(trx);
-  record->set_schema("test");
-  record->set_table("t1");
-  record->set_sql("DELETE FROM t1 WHERE a IN (1, 2)");
-
-  /* Add Field Names */
-  record->set_primary_key("a");
-
-  /* Add values for IN() */
-  value= record->add_values();
-  value->add_val("1");
-  value->add_val("2");
-}
-
-void write_update(::drizzled::message::Event *record, const char *trx)
-{
-  Event::Value *value;
-
-  record->set_type(Event::UPDATE);
-  record->set_autocommit(true);
-  record->set_server_id("localhost");
-  record->set_query_id(query_id++);
-  record->set_transaction_id(trx);
-  record->set_schema("test");
-  record->set_table("t1");
-  record->set_sql("UPDATE t1 SET a=5 WHERE a = 1 ");
-  record->set_primary_key("a");
-
-  /* Add Field Names */
-  record->add_field_names("a");
-
-  /* Add values (first row) */
-  value= record->add_values();
-  value->add_val("1"); // The first value is always the primary key comparison value
-  value->add_val("5");
-
-  /* Add values (second row) */
-  value= record->add_values();
-  value->add_val("2");
-  value->add_val("6");
-}
-
-void write_to_disk(int file, ::drizzled::message::EventList *list)
+static uint32_t server_id= 1;
+static uint64_t transaction_id= 0;
+
+uint64_t getNanoTimestamp()
+{
+#ifdef HAVE_CLOCK_GETTIME
+  struct timespec tp;
+  clock_gettime(CLOCK_REALTIME, &tp);
+  return (uint64_t) tp.tv_sec * 10000000
+       + (uint64_t) tp.tv_nsec;
+#else
+  struct timeval tv;
+  gettimeofday(&tv,NULL);
+  return (uint64_t) tv.tv_sec * 10000000
+       + (uint64_t) tv.tv_usec * 1000;
+#endif
+}
+
+void writeCommit(drizzled::message::Command &record)
+{
+  record.set_type(Command::COMMIT);
+  record.set_timestamp(getNanoTimestamp());
+
+  drizzled::message::TransactionContext *trx= record.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+}
+
+void writeRollback(drizzled::message::Command &record)
+{
+  record.set_type(Command::ROLLBACK);
+  record.set_timestamp(getNanoTimestamp());
+
+  drizzled::message::TransactionContext *trx= record.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+}
+
+void writeStartTransaction(drizzled::message::Command &record)
+{
+  record.set_type(Command::START_TRANSACTION);
+  record.set_timestamp(getNanoTimestamp());
+
+  drizzled::message::TransactionContext *trx= record.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+}
+
+void writeInsert(drizzled::message::Command &record)
+{
+  record.set_type(Command::INSERT);
+  record.set_sql("INSERT INTO t1 (a) VALUES (1) (2)");
+  record.set_timestamp(getNanoTimestamp());
+  record.set_schema("test");
+  record.set_table("t1");
+
+  drizzled::message::TransactionContext *trx= record.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+
+  drizzled::message::InsertRecord *irecord= record.mutable_insert_record();
+
+  /* Add Fields and Values... */
+
+  Table::Field *field= irecord->add_insert_field();
+  field->set_name("a");
+  field->set_type(drizzled::message::Table::Field::VARCHAR);
+
+  irecord->add_insert_value("1");
+  irecord->add_insert_value("2");
+}
+
+void writeDeleteWithPK(drizzled::message::Command &record)
+{
+  record.set_type(Command::DELETE);
+  record.set_sql("DELETE FROM t1 WHERE a = 1");
+  record.set_timestamp(getNanoTimestamp());
+  record.set_schema("test");
+  record.set_table("t1");
+
+  drizzled::message::TransactionContext *trx= record.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+
+  drizzled::message::DeleteRecord *drecord= record.mutable_delete_record();
+
+  Table::Field *field= drecord->add_where_field();
+  field->set_name("a");
+  field->set_type(drizzled::message::Table::Field::VARCHAR);
+
+  drecord->add_where_value("1");
+}
+
+void writeUpdateWithPK(drizzled::message::Command &record)
+{
+  record.set_type(Command::UPDATE);
+  record.set_sql("UPDATE t1 SET a = 5 WHERE a = 1;");
+  record.set_timestamp(getNanoTimestamp());
+  record.set_schema("test");
+  record.set_table("t1");
+
+  drizzled::message::TransactionContext *trx= record.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+
+  drizzled::message::UpdateRecord *urecord= record.mutable_update_record();
+
+  Table::Field *field;
+  
+  field= urecord->add_update_field();
+  field->set_name("a");
+  field->set_type(drizzled::message::Table::Field::VARCHAR);
+
+  urecord->add_after_value("5");
+
+  field= urecord->add_where_field();
+  field->set_name("a");
+  field->set_type(drizzled::message::Table::Field::VARCHAR);
+
+  urecord->add_where_value("1");
+}
+
+void writeTransaction(int file, drizzled::message::Transaction &transaction)
 {
   std::string buffer;
   size_t length;
   size_t written;
 
-  list->SerializePartialToString(&buffer);
+  drizzled::message::TransactionContext *trx= transaction.mutable_transaction_context();
+  trx->set_server_id(server_id);
+  trx->set_transaction_id(transaction_id);
+
+  transaction.SerializeToString(&buffer);
 
   length= buffer.length();
 
-  cout << "Writing record of " << length << "." << endl;
+  cout << "Writing transaction of " << length << " length." << endl;
 
   if ((written= write(file, &length, sizeof(uint64_t))) != sizeof(uint64_t))
   {
@@ -135,7 +168,6 @@
   }
 }
 
-
 int main(int argc, char* argv[])
 {
   GOOGLE_PROTOBUF_VERIFY_VERSION;
@@ -143,7 +175,7 @@
 
   if (argc != 2) 
   {
-    cerr << "Usage:  " << argv[0] << " REPLICATION_EVENT_LOG " << endl;
+    cerr << "Usage:  " << argv[0] << " TRANSACTION_LOG" << endl;
     return -1;
   }
 
@@ -153,20 +185,31 @@
    exit(0);
   }
 
-  EventList list;
-
-  /* Write first set of records */
-  write_ddl(list.add_event(), "CREATE TABLE A (a int) ENGINE=innodb");
-  write_insert(list.add_event(), transaction_id);
-
-  write_to_disk(file, &list);
-
-  /* Write Second set of records */
-  write_ddl(list.add_event(), "CREATE TABLE A (a int) ENGINE=innodb");
-  write_delete(list.add_event(), transaction_id);
-  write_update(list.add_event(), transaction_id);
-
-  write_to_disk(file, &list);
+  /* Write a series of statements which test each type of record class */
+  transaction_id++;
+
+  /* Simple INSERT statement */
+  Transaction transaction;
+  transaction.set_start_timestamp(getNanoTimestamp());
+  writeStartTransaction(*transaction.add_command());
+  writeInsert(*transaction.add_command());
+  writeCommit(*transaction.add_command());
+  transaction.set_end_timestamp(getNanoTimestamp());
+
+  writeTransaction(file, transaction);
+
+  transaction.Clear();
+
+  /* Write a DELETE and an UPDATE in one transaction */
+  transaction_id++;
+  transaction.set_start_timestamp(getNanoTimestamp());
+  writeStartTransaction(*transaction.add_command());
+  writeDeleteWithPK(*transaction.add_command());
+  writeUpdateWithPK(*transaction.add_command());
+  writeCommit(*transaction.add_command());
+  transaction.set_end_timestamp(getNanoTimestamp());
+
+  writeTransaction(file, transaction);
 
   close(file);
 

=== added file 'drizzled/plugin/applier.h'
--- drizzled/plugin/applier.h	1970-01-01 00:00:00 +0000
+++ drizzled/plugin/applier.h	2009-04-10 17:06:58 +0000
@@ -0,0 +1,83 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008-2009 Sun Microsystems
+ *
+ *  Authors:
+ *
+ *    Jay Pipes <joinfu@sun.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_PLUGIN_APPLIER_H
+#define DRIZZLED_PLUGIN_APPLIER_H
+
+/**
+ * @file Defines the API for an Applier
+ *
+ * An Applier applies an event it has received from a Replicator (via 
+ * a replicator's replicate() call, or it has read using a Reader's read()
+ * call.
+ */
+
+/* some forward declarations needed */
+namespace drizzled
+{
+  namespace message
+  {
+    class Command;
+  }
+}
+
+namespace drizzled
+{
+namespace plugin
+{
+
+/**
+ * Base class for appliers of Command messages
+ */
+class Applier
+{
+public:
+  Applier() {}
+  virtual ~Applier() {}
+  /**
+   * Apply something to a target.
+   *
+   * @note
+   *
+   * It is important to note that memory allocation for the 
+   * supplied pointer is not guaranteed after the completion 
+   * of this function -- meaning the caller can dispose of the
+   * supplied message.  Therefore, appliers which are
+   * implementing an asynchronous replication system must copy
+   * the supplied message to their own controlled memory storage
+   * area.
+   *
+   * @param Command message to be replicated
+   */
+  virtual void apply(drizzled::message::Command *to_apply)= 0;
+  /** 
+   * An applier plugin should override this with its
+   * internal method for determining if it is active or not.
+   */
+  virtual bool isActive() {return false;}
+};
+
+} /* end namespace drizzled::plugin */
+} /* end namespace drizzled */
+
+#endif /* DRIZZLED_PLUGIN_APPLIER_H */

=== modified file 'drizzled/plugin/replicator.h'
--- drizzled/plugin/replicator.h	2009-03-22 08:32:24 +0000
+++ drizzled/plugin/replicator.h	2009-04-10 17:06:58 +0000
@@ -1,125 +1,85 @@
-/*
-  -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
-  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
-
-  *  Definitions required for Configuration Variables plugin
-
-  *  Copyright (C) 2008 Mark Atwood
-  *
-  *  This program is free software; you can redistribute it and/or modify
-  *  it under the terms of the GNU General Public License as published by
-  *  the Free Software Foundation; version 2 of the License.
-  *
-  *  This program is distributed in the hope that it will be useful,
-  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
-  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  *  GNU General Public License for more details.
-  *
-  *  You should have received a copy of the GNU General Public License
-  *  along with this program; if not, write to the Free Software
-  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-  */
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008-2009 Sun Microsystems
+ *
+ *  Authors:
+ *
+ *    Jay Pipes <joinfu@sun.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
 
 #ifndef DRIZZLED_PLUGIN_REPLICATOR_H
 #define DRIZZLED_PLUGIN_REPLICATOR_H
 
 /**
- * @file
- *
- * Defines the API for Replication
+ * @file Defines the API for a Replicator.  
+ *
+ * All a replicator does is replicate/reproduce
+ * events, optionally transforming them before sending them off to an applier.
+ *
+ * An applier is responsible for applying events, not a replicator...
  */
 
+/* some forward declarations needed */
+namespace drizzled
+{
+  namespace message
+  {
+    class Command;
+  }
+  class Applier;
+}
+
+namespace drizzled
+{
+namespace plugin
+{
+
 /**
- * Base class for replication implementations.
- *
- *    if a method returns bool true, that means it failed.
+ * Class which replicates Command messages
  */
 class Replicator
 {
-private:
-  bool enabled;
-protected:
-  virtual bool session_init_hook(Session *) { return false; }
-  virtual bool row_insert_hook(Session *, Table *) { return false; }
-  virtual bool row_update_hook(Session *, Table *,
-                               const unsigned char *,
-                               const unsigned char *) { return false; }
-  virtual bool row_delete_hook(Session *, Table *) { return false; }
-  virtual bool end_transaction_hook(Session *, bool, bool) { return false; }
-  virtual bool statement_hook(Session *, const char *, size_t) { return false; }
 public:
-
-  Replicator() : enabled(true) {}
-
+  Replicator() {}
   virtual ~Replicator() {}
   /**
-   * Initialize session for replication
-   */
-  bool session_init(Session *session)
-  {
-    return session_init_hook(session);
-  }
-
-  /**
-   * Row insert
-   *
-   * @param current Session
-   * @param Table inserted
-   */
-  bool row_insert(Session *session, Table *table)
-  {
-    return row_insert_hook(session, table);
-  }
-
-  /**
-   * Row update
-   *
-   * @param current Session
-   * @param Table updated
-   * @param before values
-   * @param after values
-   */
-  bool row_update(Session *session, Table *table,
-                          const unsigned char *before,
-                          const unsigned char *after)
-  {
-    return row_update_hook(session, table, before, after);
-  }
-
-  /**
-   * Row Delete
-   *
-   * @param current session
-   * @param Table deleted from
-   */
-  bool row_delete(Session *session, Table *table)
-  {
-    return row_delete_hook(session, table);
-  }
-
-  /**
-   * End Transaction
-   *
-   * @param current Session
-   * @param is autocommit on?
-   * @param did the transaction commit?
-   */
-  bool end_transaction(Session *session, bool autocommit, bool commit)
-  {
-    return end_transaction_hook(session, autocommit, commit);
-  }
-
-  /**
-   * Raw statement
-   *
-   * @param current Session
-   * @param query string
-   * @param length of query string in bytes
-   */
-  bool statement(Session *session, const char *query, size_t query_length)
-  {
-    return statement_hook(session, query, query_length);
-  }
+   * Replicate a Command message to an Applier.
+   *
+   * @note
+   *
+   * It is important to note that memory allocation for the 
+   * supplied pointer is not guaranteed after the completion 
+   * of this function -- meaning the caller can dispose of the
+   * supplied message.  Therefore, replicators and appliers 
+   * implementing an asynchronous replication system must copy
+   * the supplied message to their own controlled memory storage
+   * area.
+   *
+   * @param Command message to be replicated
+   */
+  virtual void replicate(Applier *in_applier, drizzled::message::Command *to_replicate)= 0;
+  /** 
+   * A replicator plugin should override this with its
+   * internal method for determining if it is active or not.
+   */
+  virtual bool isActive() {return false;}
 };
 
+} /* end namespace drizzled::plugin */
+} /* end namespace drizzled */
+
 #endif /* DRIZZLED_PLUGIN_REPLICATOR_H */

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2009-04-10 16:20:58 +0000
+++ drizzled/session.h	2009-04-10 17:06:58 +0000
@@ -968,7 +968,13 @@
     start_utime= utime_after_lock= my_micro_time();
   }
   void set_time_after_lock()  { utime_after_lock= my_micro_time(); }
-  uint64_t current_utime()  { return my_micro_time(); }
+  /**
+   * Returns the current micro-timestamp
+   */
+  inline uint64_t getCurrentTimestamp()  
+  { 
+    return my_micro_time(); 
+  }
   inline uint64_t found_rows(void)
   {
     return limit_found_rows;

=== renamed file 'drizzled/replicator.cc' => 'drizzled/transaction_services.cc'
--- drizzled/replicator.cc	2009-04-08 03:29:53 +0000
+++ drizzled/transaction_services.cc	2009-04-10 17:06:58 +0000
@@ -1,7 +1,11 @@
 /* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
- *  Copyright (C) 2008 Mark Atwood
+ *  Copyright (C) 2008-2009 Sun Microsystems
+ *
+ *  Authors:
+ *
+ *    Jay Pipes <joinfu@sun.com>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -17,18 +21,56 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
-#include <drizzled/server_includes.h>
-#include <drizzled/replicator.h>
-#include <drizzled/gettext.h>
-#include <drizzled/session.h>
-
+/**
+ * @file Server-side utility which is responsible for managing the 
+ * communication between the kernel, replicator plugins, and applier plugins.
+ *
+ * TransactionServices is a bridge between modules and the kernel, and its
+ * primary function is to take internal events (for instance the start of a 
+ * transaction, the changing of a record, or the rollback of a transaction) 
+ * and construct GPB Messages that are passed to the registered replicator and
+ * applier plugins.
+ *
+ * The reason for this functionality is to encapsulate all communication
+ * between the kernel and the replicator/applier plugins into GPB Messages.
+ * Instead of the plugin having to understand the (often fluidly changing)
+ * mechanics of the kernel, all the plugin needs to understand is the message
+ * format, and GPB messages provide a nice, clear, and versioned format for 
+ * these messages.
+ *
+ * @see /drizzled/message/transaction.proto
+ */
+
+#include "drizzled/server_includes.h"
+#include "drizzled/transaction_services.h"
+#include "drizzled/plugin/replicator.h"
+#include "drizzled/plugin/applier.h"
+#include "drizzled/message/transaction.pb.h"
+#include "drizzled/message/table.pb.h"
+#include "drizzled/gettext.h"
+#include "drizzled/session.h"
+
+#include <vector>
+
+drizzled::TransactionServices transaction_services;
+
+/**
+ * @TODO
+ *
+ * We're going to start simple at first, meaning that the 
+ * below are the global vectors of replicators and appliers. The
+ * end goal is to have the TransactionServices have a register method
+ * which allows modules to register Replicator or Applier *factories*, 
+ * which will allow TransactionServices to attach and detach a replicator/applier
+ * to a Session, instead of the current global vector.
+ */
 int replicator_initializer(st_plugin_int *plugin)
 {
-  Replicator *p= NULL;
+  drizzled::plugin::Replicator *repl= NULL;
 
   if (plugin->plugin->init)
   {
-    if (plugin->plugin->init((void *)&p))
+    if (plugin->plugin->init(&repl))
     {
       /* TRANSLATORS: The leading word "replicator" is the name
         of the plugin api, and so should not be translated. */
@@ -39,51 +81,265 @@
     }
   }
 
-  plugin->data= (void *)p;
+  if (repl == NULL)
+    return 1;
+
+  transaction_services.attachReplicator(repl);
+  plugin->data= repl;
 
   return 0;
 }
 
 int replicator_finalizer(st_plugin_int *plugin)
 {
-  Replicator *p= static_cast<Replicator *>(plugin->data);
+  drizzled::plugin::Replicator *repl= static_cast<drizzled::plugin::Replicator *>(plugin->data);
+  
+  assert(repl);
+
+  transaction_services.detachReplicator(repl);
 
   if (plugin->plugin->deinit)
-    {
-      if (plugin->plugin->deinit((void *)p))
-        {
-          /* TRANSLATORS: The leading word "replicator" is the name
-             of the plugin api, and so should not be translated. */
-          errmsg_printf(ERRMSG_LVL_ERROR,
-                        _("replicator plugin '%s' deinit() failed"),
-                        plugin->name.str);
-        }
-    }
+    (void) plugin->plugin->deinit(repl);
 
   return 0;
 }
 
+namespace drizzled
+{
+
+void TransactionServices::attachReplicator(drizzled::plugin::Replicator *in_replicator)
+{
+  replicators.push_back(in_replicator);
+}
+
+void TransactionServices::detachReplicator(drizzled::plugin::Replicator *in_replicator)
+{
+  replicators.erase(std::find(replicators.begin(), replicators.end(), in_replicator));
+}
+
+void TransactionServices::attachApplier(drizzled::plugin::Applier *in_applier)
+{
+  appliers.push_back(in_applier);
+}
+
+void TransactionServices::detachApplier(drizzled::plugin::Applier *in_applier)
+{
+  appliers.erase(std::find(appliers.begin(), appliers.end(), in_applier));
+}
+
+void TransactionServices::setCommandTransactionContext(drizzled::message::Command *in_command
+                                                     , Session *in_session) const
+{
+  using namespace drizzled::message;
+
+  TransactionContext *trx= in_command->mutable_transaction_context();
+  trx->set_server_id(in_session->getServerId());
+  trx->set_transaction_id(in_session->getTransactionId());
+}
+
+void TransactionServices::startTransaction(Session *in_session)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::START_TRANSACTION);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+  
+  push(&command);
+}
+
+void TransactionServices::commitTransaction(Session *in_session)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::COMMIT);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+  
+  push(&command);
+}
+
+void TransactionServices::rollbackTransaction(Session *in_session)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::ROLLBACK);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+  
+  push(&command);
+}
+
+void TransactionServices::insertRecord(Session *in_session, Table *in_table)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::INSERT);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+
+  const char *schema_name= in_table->getShare()->db.str;
+  const char *table_name= in_table->getShare()->table_name.str;
+
+  command.set_schema(schema_name);
+  command.set_table(table_name);
+
+  /* 
+   * Now we construct the specialized InsertRecord command inside
+   * the Command container...
+   */
+  InsertRecord *change_record= command.mutable_insert_record();
+
+  Field *current_field;
+  Field **table_fields= in_table->field;
+  String *string_value= new (in_session->mem_root) String(100); /* 100 initially. field->val_str() is responsible for re-adjusting */
+  string_value->set_charset(system_charset_info);
+
+  Table::Field *cur_field;
+
+  while ((current_field= *table_fields++) != NULL) 
+  {
+    cur_field= change_record->add_insert_field();
+    cur_field->set_name(std::string(current_field->field_name));
+    cur_field->set_type(Table::Field::VARCHAR); /* @TODO real types! */
+    string_value= current_field->val_str(string_value);
+    change_record->add_insert_value(std::string(string_value->c_ptr()));
+    string_value->free(); /* I wish there was a clear() method... */
+  }
+  
+  push(&command);
+}
+
+void TransactionServices::updateRecord(Session *in_session, Table *in_table, const unsigned char *, const unsigned char *)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::UPDATE);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+
+  const char *schema_name= in_table->getShare()->db.str;
+  const char *table_name= in_table->getShare()->table_name.str;
+
+  command.set_schema(schema_name);
+  command.set_table(table_name);
+
+  /* 
+   * Now we construct the specialized UpdateRecord command inside
+   * the Command container...
+   */
+  //UpdateRecord *change_record= command.mutable_update_record();
+
+  push(&command);
+}
+
+void TransactionServices::deleteRecord(Session *in_session, Table *in_table)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::DELETE);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+
+  const char *schema_name= in_table->getShare()->db.str;
+  const char *table_name= in_table->getShare()->table_name.str;
+
+  command.set_schema(schema_name);
+  command.set_table(table_name);
+
+  /* 
+   * Now we construct the specialized DeleteRecord command inside
+   * the Command container...
+   */
+  //DeleteRecord *change_record= command.mutable_delete_record();
+  
+  push(&command);
+}
+
+void TransactionServices::rawStatement(Session *in_session, const char *in_query, size_t in_query_len)
+{
+  using namespace drizzled::message;
+  
+  Command command;
+  command.set_type(Command::RAW_SQL);
+  command.set_timestamp(in_session->getCurrentTimestamp());
+
+  setCommandTransactionContext(&command, in_session);
+
+  std::string query(in_query, in_query_len);
+  command.set_sql(query);
+
+  push(&command);
+  
+}
+
+void TransactionServices::push(drizzled::message::Command *to_push)
+{
+  std::vector<drizzled::plugin::Replicator *>::iterator repl_iter= replicators.begin();
+  std::vector<drizzled::plugin::Applier *>::iterator appl_start_iter, appl_iter;
+  appl_start_iter= appliers.begin();
+
+  drizzled::plugin::Replicator *cur_repl;
+  drizzled::plugin::Applier *cur_appl;
+
+  while (repl_iter != replicators.end())
+  {
+    cur_repl= *repl_iter;
+    if (! cur_repl->isActive())
+    {
+      ++repl_iter;
+      continue;
+    }
+    
+    appl_iter= appl_start_iter;
+    while (appl_iter != appliers.end())
+    {
+      cur_appl= *appl_iter;
+
+      if (! cur_appl->isActive())
+      {
+        ++appl_iter;
+        continue;
+      }
+
+      cur_repl->replicate(cur_appl, to_push);
+      ++appl_iter;
+    }
+    ++repl_iter;
+  }
+}
+
+#ifdef oldcode
 /* This gets called by plugin_foreach once for each loaded replicator plugin */
-static bool replicator_session_iterate(Session *session, st_plugin_int *plugin, void *)
+static bool replicator_session_iterate(Session *session, plugin_ref plugin, void *)
 {
-  Replicator *repl= plugin_data(plugin, Replicator *);
-  bool error;
+  drizzled::plugin::Replicator *repl= plugin_data(plugin, drizzled::plugin::Replicator *);
+
+  if (! repl || ! repl->isActive())
+    return false;
 
   /* call this loaded replicator plugin's session_init method */
-  if (repl)
+  if (! repl->initSession(session))
   {
-    error= repl->session_init(session);
-    if (error)
-    {
-      /* TRANSLATORS: The leading word "replicator" is the name
-        of the plugin api, and so should not be translated. */
-      errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("replicator plugin '%s' session_init() failed"),
-                    (char *)plugin_name(plugin));
-      return true;
-    }
+    /* TRANSLATORS: The leading word "replicator" is the name
+      of the plugin api, and so should not be translated. */
+    errmsg_printf(ERRMSG_LVL_ERROR,
+                  _("replicator plugin '%s' session_init() failed"),
+                  (char *)plugin_name(plugin));
+    return true;
   }
-
   return false;
 }
 
@@ -99,9 +355,6 @@
     trans_register_ha(session, true, binlog_engine);
   trans_register_ha(session, false, binlog_engine);
 
-  if (session->getReplicationData())
-    return false;
-
   /* 
     call replicator_session_iterate
     once for each loaded replicator plugin
@@ -111,7 +364,6 @@
 
   return foreach_rv;
 }
-
 /* The plugin_foreach() iterator requires that we
    convert all the parameters of a plugin api entry point
    into just one single void ptr, plus the session.
@@ -119,7 +371,8 @@
    and marshall them into a struct of this type, and
    then just pass in a pointer to it.
 */
-enum repl_row_exec_t{
+enum repl_row_exec_t
+{
   repl_insert,
   repl_update,
   repl_delete
@@ -135,32 +388,75 @@
 
 
 /* This gets called by plugin_foreach once for each loaded replicator plugin */
-static bool replicator_do_row_iterate (Session *session, st_plugin_int *plugin, void *p)
+static bool replicator_do_row_iterate (Session *session, plugin_ref plugin, void *p)
 {
-  Replicator *repl= plugin_data(plugin, Replicator *);
+  drizzled::plugin::Replicator *repl= plugin_data(plugin, drizzled::plugin::Replicator *);
+
+  if (! repl || ! repl->isActive())
+    return false;
+
   replicator_row_parms_st *params= static_cast<replicator_row_parms_st *>(p);
 
-  switch (params->type) {
-  case repl_insert:
-    if (repl)
+  /* 
+   * We create a container ChangeRecord and then specialize the change
+   * record depending on the actual event which occurred...
+   */
+  drizzled::message::ChangeRecord change_record;
+  /** 
+   * When inserting a row, we want to pass the replicator only the
+   * specific information it needs, which is the name of the schema, 
+   * the name of the table, the list of field names in the field list of
+   * the INSERT expression, and the values of this written row as strings.
+   *
+   * @TODO  Eventually, it would be better to simply pass a Table 
+   *        proto message instead of both a schema name and a table
+   *        name.
+   *
+   * @TODO  Better to not have to pass string values...
+   *
+   * @TODO  Pass pointers here instead of copies of values/field names?
+   *        For large inserts, might be in trouble of running out of 
+   *        stack space? Not sure...
+   *
+   * @TODO  Ugh, get rid of the friggin custom String shit.
+   */
+  const char *schema_name= params->table->getShare()->db.str;
+  const char *table_name= params->table->getShare()->table_name.str;
+
+  change_record.set_schema(schema_name);
+  change_record.set_table(table_name);
+  switch (params->type) 
+  {
+    case repl_insert:
     {
-      if (repl->row_insert(session, params->table))
+
+      drizzled::message::InsertRecord *irecord= change_record.mutable_insert_record();
+
+      std::vector<std::string> values;
+      std::vector<std::string> field_names;
+
+      Field *current_field;
+      Field **table_fields= params->table->field;
+      String *string_value= new (session->mem_root) String(100); /* 100 initially. field->val_str() is responsible for re-adjusting */
+      string_value->set_charset(system_charset_info);
+
+      while ((current_field= *table_fields++) != NULL) 
       {
-        /* TRANSLATORS: The leading word "replicator" is the name
-          of the plugin api, and so should not be translated. */
-        errmsg_printf(ERRMSG_LVL_ERROR,
-                      _("replicator plugin '%s' row_insert() failed"),
-                     (char *)plugin_name(plugin));
 
-        return true;
+        field_names.push_back(std::string(current_field->field_name));
+        string_value= current_field->val_str(string_value);
+        values.push_back(std::string(string_value->c_ptr()));
+        string_value->free(); /* I wish there was a clear() method... */
       }
+
+      repl->replicate(appl, &change_record);
+      if (string_value)
+        delete string_value;
+      break;
     }
-    break;
-  case repl_update:
-    if (repl)
+    case repl_update:
     {
-      if (repl->row_update(session, params->table,
-                           params->before, params->after))
+      if (! repl->updateRow(session, params->table, params->before, params->after))
       {
         /* TRANSLATORS: The leading word "replicator" is the name
           of the plugin api, and so should not be translated. */
@@ -170,12 +466,11 @@
 
         return true;
       }
+      break;
     }
-    break;
-  case repl_delete:
-    if (repl)
+    case repl_delete:
     {
-      if (repl->row_delete(session, params->table))
+      if (! repl->deleteRow(session, params->table))
       {
         /* TRANSLATORS: The leading word "replicator" is the name
           of the plugin api, and so should not be translated. */
@@ -185,8 +480,8 @@
 
         return true;
       }
+      break;
     }
-    break;
   }
   return false;
 }
@@ -254,25 +549,24 @@
 } replicator_row_end_st;
 
 /* We call this to end a statement (on each registered plugin) */
-static bool replicator_end_transaction_iterate (Session *session, st_plugin_int *plugin, void *p)
+static bool replicator_end_transaction_iterate (Session *session, plugin_ref plugin, void *p)
 {
-  Replicator *repl= plugin_data(plugin, Replicator *);
+  drizzled::plugin::Replicator *repl= plugin_data(plugin, drizzled::plugin::Replicator *);
   replicator_row_end_st *params= static_cast<replicator_row_end_st *>(p);
 
+  if (! repl || ! repl->isActive())
+    return false;
+
   /* call this loaded replicator plugin's replicator_func1 function pointer */
-  if (repl)
+  if (! repl->endTransaction(session, params->autocommit, params->commit))
   {
-    if (repl->end_transaction(session, params->autocommit, params->commit))
-    {
-      /* TRANSLATORS: The leading word "replicator" is the name
-        of the plugin api, and so should not be translated. */
-      errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("replicator plugin '%s' end_transaction() failed"),
-                    (char *)plugin_name(plugin));
-      return true;
-    }
+    /* TRANSLATORS: The leading word "replicator" is the name
+      of the plugin api, and so should not be translated. */
+    errmsg_printf(ERRMSG_LVL_ERROR,
+                  _("replicator plugin '%s' end_transaction() failed"),
+                  (char *)plugin_name(plugin));
+    return true;
   }
-
   return false;
 }
 
@@ -311,26 +605,25 @@
   size_t query_length;
 } replicator_statement_st;
 
-/* We call this to end a statement (on each registered plugin) */
-static bool replicator_statement_iterate(Session *session, st_plugin_int *plugin, void *p)
+/* We call this to begin a statement (on each registered plugin) */
+static bool replicator_statement_iterate(Session *session, plugin_ref plugin, void *p)
 {
-  Replicator *repl= plugin_data(plugin, Replicator *);
+  drizzled::plugin::Replicator *repl= plugin_data(plugin, drizzled::plugin::Replicator *);
   replicator_statement_st *params= (replicator_statement_st *)p;
 
+  if (! repl || ! repl->isActive())
+    return false;
+
   /* call this loaded replicator plugin's replicator_func1 function pointer */
-  if (repl)
+  if (! repl->beginStatement(session, params->query, params->query_length))
   {
-    if (repl->statement(session, params->query, params->query_length))
-    {
-      /* TRANSLATORS: The leading word "replicator" is the name
-        of the plugin api, and so should not be translated. */
-      errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("replicator plugin '%s' statement() failed"),
-                    (char *)plugin_name(plugin));
-      return true;
-    }
+    /* TRANSLATORS: The leading word "replicator" is the name
+      of the plugin api, and so should not be translated. */
+    errmsg_printf(ERRMSG_LVL_ERROR,
+                  _("replicator plugin '%s' statement() failed"),
+                  (char *)plugin_name(plugin));
+    return true;
   }
-
   return false;
 }
 
@@ -348,3 +641,6 @@
 
   return foreach_rv;
 }
+#endif /* oldcode */
+
+} /* end namespace drizzled */

=== renamed file 'drizzled/replicator.h' => 'drizzled/transaction_services.h'
--- drizzled/replicator.h	2009-03-22 08:32:24 +0000
+++ drizzled/transaction_services.h	2009-04-10 17:06:58 +0000
@@ -1,7 +1,7 @@
 /* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
- *  Copyright (C) 2008 Mark Atwood
+ *  Copyright (C) 2008-2009 Sun Microsystems
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -20,11 +20,148 @@
 #ifndef DRIZZLED_REPLICATOR_H
 #define DRIZZLED_REPLICATOR_H
 
-#include <drizzled/plugin/replicator.h>
+#include <vector>
 
 int replicator_initializer (st_plugin_int *plugin);
 int replicator_finalizer (st_plugin_int *plugin);
 
+/* some forward declarations needed */
+class Session;
+class Table;
+
+namespace drizzled
+{
+  namespace plugin
+  {
+    class Replicator;
+    class Applier;
+  }
+  namespace message
+  {
+    class Command;
+  }
+}
+
+/**
+ * This is a class which manages transforming internal 
+ * transactional events into GPB messages and sending those
+ * events out through registered replicators and appliers.
+ */
+namespace drizzled
+{
+class TransactionServices
+{
+private:
+  /** Our collection of replicator plugins */
+  std::vector<drizzled::plugin::Replicator *> replicators;
+  /** Our collection of applier plugins */
+  std::vector<drizzled::plugin::Applier *> appliers;
+  /** 
+   * Helper method which attaches a transaction context
+   * the supplied command based on the supplied Session's
+   * transaction information.
+   */
+  void setCommandTransactionContext(drizzled::message::Command *in_command, Session *in_session) const;
+  /**
+   * Helper method which pushes a constructed message out
+   * to the registered replicator and applier plugins.
+   *
+   * @param Message to push out
+   */
+  void push(drizzled::message::Command *to_push);
+public:
+  /**
+   * Attaches a replicator to our internal collection of
+   * replicators.
+   *
+   * @param Pointer to a replicator to attach/register
+   */
+  void attachReplicator(drizzled::plugin::Replicator *in_replicator);
+  /**
+   * Detaches/unregisters a replicator with our internal
+   * collection of replicators.
+   *
+   * @param Pointer to the replicator to detach
+   */
+  void detachReplicator(drizzled::plugin::Replicator *in_replicator);
+  /**
+   * Attaches a applier to our internal collection of
+   * appliers.
+   *
+   * @param Pointer to a applier to attach/register
+   */
+  void attachApplier(drizzled::plugin::Applier *in_applier);
+  /**
+   * Detaches/unregisters a applier with our internal
+   * collection of appliers.
+   *
+   * @param Pointer to the applier to detach
+   */
+  void detachApplier(drizzled::plugin::Applier *in_applier);
+  /**
+   * Creates a new StartTransaction GPB message and pushes
+   * it to replicators.
+   *
+   * @param Pointer to the Session starting the transaction
+   */
+  void startTransaction(Session *in_session);
+  /**
+   * Creates a new CommitTransaction GPB message and pushes
+   * it to replicators.
+   *
+   * @param Pointer to the Session committing the transaction
+   */
+  void commitTransaction(Session *in_session);
+  /**
+   * Creates a new RollbackTransaction GPB message and pushes
+   * it to replicators.
+   *
+   * @param Pointer to the Session committing the transaction
+   */
+  void rollbackTransaction(Session *in_session);
+  /**
+   * Creates a new InsertRecord GPB message and pushes it to
+   * replicators.
+   *
+   * @param Pointer to the Session which has inserted a record
+   * @param Pointer to the Table containing insert information
+   */
+  void insertRecord(Session *in_session, Table *in_table);
+  /**
+   * Creates a new UpdateRecord GPB message and pushes it to
+   * replicators.
+   *
+   * @param Pointer to the Session which has updated a record
+   * @param Pointer to the Table containing update information
+   */
+  void updateRecord(Session *in_session, Table *in_table, const unsigned char *, const unsigned char *);
+  /**
+   * Creates a new DeleteRecord GPB message and pushes it to
+   * replicators.
+   *
+   * @param Pointer to the Session which has deleted a record
+   * @param Pointer to the Table containing delete information
+   */
+  void deleteRecord(Session *in_session, Table *in_table);
+  /**
+   * Creates a new RawSql GPB message and pushes it to 
+   * replicators.
+   *
+   * @TODO With a real data dictionary, this really shouldn't
+   * be needed.  CREATE TABLE would map to insertRecord call
+   * on the I_S, etc.  Not sure what to do with administrative
+   * commands like CHECK TABLE, though..
+   *
+   * @param Pointer to the Session which issued the statement
+   * @param Query string
+   * @param Length of the query string
+   */
+  void rawStatement(Session *in_session, const char *in_query, size_t in_query_len);
+};
+
+} /* end namespace drizzled */
+
+#ifdef oldcode
 /* todo, fill in this API */
 /* these are the functions called by the rest of the drizzle server
    to do whatever this plugin does. */
@@ -39,5 +176,5 @@
 bool replicator_end_transaction(Session *session, bool autocommit, bool commit);
 bool replicator_prepare(Session *session);
 bool replicator_statement(Session *session, const char *query, size_t query_length);
-
+#endif /* oldcode */
 #endif /* DRIZZLED_REPLICATOR_H */

